/**CHeaderFile*****************************************************************

  FileName    [mcInt.h]

  PackageName [mc]

  Synopsis    [Internal header file of the mc package.]

  Description [Internal header file of the mc package.]

  SeeAlso     [ mcMc.c mcExplain.c]

  Author      [Marco Roveri]

  Copyright   [ Copyright (c) 1998 by ITC-IRST and Carnegie Mellon University.
  All Rights Reserved. This software is for educational purposes only.
  Permission is given to academic institutions to use, copy, and modify
  this software and its documentation provided that this introductory
  message is not removed, that this software and its documentation is
  used for the institutions' internal research and educational purposes,
  and that no monies are exchanged. No guarantee is expressed or implied
  by the distribution of this code.
  Send bug-reports and/or questions to: nusmv@irst.itc.it. ]

  Revision    [$Id: $]

******************************************************************************/

#ifndef _MCINT
#define _MCINT

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>

#include "sm.h"
#include "util.h"
#include "utils.h"
#include "node.h"
#include "dd.h"
#include "grammar.h"
#include "parser.h"
#include "img.h"
#include "compile.h"
#include "opt.h"
#include "mc.h"

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/

extern FILE * nusmv_stderr;
extern FILE * nusmv_stdout;
extern DdManager * dd_manager;
extern int yylineno;
extern options_ptr options;
extern cmp_struct_ptr cmps;

extern node_ptr one_number;
extern node_ptr zero_number;

extern bdd_ptr invar_bdd;
extern bdd_ptr init_bdd;
extern bdd_ptr reachable_states_bdd;
extern node_ptr reachable_states_layers;
extern node_ptr fairness_constraints_bdd;
extern bdd_ptr fair_states_bdd;

extern node_ptr real_state_variables;
extern add_ptr process_selector_add;
extern bdd_ptr input_variables_bdd;

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/
EXTERN node_ptr ex_explain       ARGS((node_ptr p, bdd_ptr f));
EXTERN node_ptr eu_explain       ARGS((node_ptr p, bdd_ptr f, bdd_ptr g));
EXTERN node_ptr ebu_explain      ARGS((node_ptr p, bdd_ptr f, bdd_ptr g, int inf, int sup));
EXTERN node_ptr eg_explain       ARGS((node_ptr p, bdd_ptr g));
EXTERN node_ptr ebg_explain      ARGS((node_ptr p, bdd_ptr g, int inf, int sup));

#endif /* _MCINT */
