 /**CHeaderFile*****************************************************************

  FileName    [simulateInt.h]

  PackageName [simulate]

  Synopsis    [Internal Header File for the simulate package]

  Description [Internal Header File for the simulate package]

  SeeAlso     [simulate.c]

  Author      [Andrea Morichetti]

  Copyright   [ Copyright (c) 1998 by ITC-IRST and Carnegie Mellon University.
  All Rights Reserved. This software is for educational purposes only.
  Permission is given to academic institutions to use, copy, and modify
  this software and its documentation provided that this introductory
  message is not removed, that this software and its documentation is
  used for the institutions' internal research and educational purposes,
  and that no monies are exchanged. No guarantee is expressed or implied
  by the distribution of this code.
  Send bug-reports and/or questions to: nusmv@irst.itc.it. ]

  Revision    [$Id: $]

******************************************************************************/

#ifndef _SIMULATEINT
#define _SIMULATEINT

#include <stdio.h>
#include <stdlib.h>

#if HAVE_SYS_SIGNAL_h
#  include <sys/signal.h>
#endif
#if HAVE_SIGNAL_H
#  include <signal.h>
#endif

#include <setjmp.h>

#include <assert.h>

#include "sm.h"
#include "util.h"
#include "utils.h"
#include "node.h"
#include "dd.h"
#include "grammar.h"
#include "parser.h"
#include "img.h"
#include "compile.h"
#include "opt.h"
#include "mc.h"

#include "simulate.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/
/* maximum lenght of the string containing constraints */
#define CONSTR_LENGTH 256
/* Lenght of the string used for the choice entered in interac. sim.*/
#define CHOICE_LENGTH 8


extern DdManager * dd_manager;
extern options_ptr options;
extern cmp_struct_ptr cmps;
extern int trace_number;
extern bdd_ptr invar_bdd;
extern bdd_ptr state_vars[];
extern int state_vars_dim;
extern bdd_ptr init_bdd;

#endif /* _SIMULATEINT */
